"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const utils_1 = require("./utils");
const html_minifier_terser_1 = require("html-minifier-terser");
const defaultMinifyOptions = {
    minifyCSS: true,
    minifyJS: true,
    minifyURLs: true,
    removeAttributeQuotes: true,
    trimCustomFragments: true,
    collapseWhitespace: true,
};
exports.default = (opt = {}) => {
    return {
        indexHtmlTransforms: [
            {
                apply: 'pre',
                transform: ({ code }) => {
                    const { options = {} } = opt;
                    try {
                        const compiled = lodash_1.template(code);
                        return compiled({
                            viteHtmlPluginOptions: options,
                        });
                    }
                    catch (error) {
                        console.warn('[vite-plugin-html:pre]:Template Compiled Faild\n' + error);
                        return code;
                    }
                },
            },
            {
                apply: 'post',
                transform: ({ code, isBuild }) => {
                    const { title = '', minify = isBuild } = opt;
                    try {
                        let processCode = utils_1.injectTitle(code, title);
                        if (!minify) {
                            return processCode;
                        }
                        if (lodash_1.isBoolean(minify)) {
                            return html_minifier_terser_1.minify(processCode, defaultMinifyOptions);
                        }
                        return html_minifier_terser_1.minify(processCode, {
                            ...defaultMinifyOptions,
                            ...minify,
                        });
                    }
                    catch (error) {
                        console.warn('[vite-plugin-html:post]:Template Compiled Faild\n' + error);
                        return code;
                    }
                },
            },
        ],
    };
};
__exportStar(require("./types"), exports);
